module.exports = {
  title: "PHP程序员的FreeSWITCH开发文档",
  description: "一个PHP程序在做FreeSWITCH相关的应用开发时积累的技术文档",
  dest: "dist",
  themeConfig: {
    displayAllHeaders: false,
    sidebar: [
      {
        title: "README",
        path: "/",
        sidebarDepth: 0,
      },
      {
        title: "FreeSWITCH",
        children: [
          "/freeswitch/安装freeswitch1.6",
          "/freeswitch/Debian11安装FreeSWITCH1.10",
          "/freeswitch/Debian11安装FreeSWITCH1.10-参照ClueCon官方文档",
          "/freeswitch/Debian11安装lua和luarocks",
          "/freeswitch/为FreeSWITCH安装mod_unimrcp模块",
          "/freeswitch/FreeSWITCH对接阿里云MRCP",
          "/freeswitch/freeswitch对接百度mrcp",
          "/freeswitch/freeswitch配置ssl",
          "/freeswitch/搭建STUN服务",
          "/freeswitch/恶意SIP行为IP黑名单",
        ],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
      {
        title: "前端",
        children: [
          "/frontend/解决create-vue创建的项目运行后提示Network: use --host to expose的问题",
          "/frontend/在linux中安装node二进制文件",
          "/frontend/在vscode里配置vetur符合eslint",
          "/frontend/npm切换源",
        ],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
      {
        title: "PHP",
        children: ["/php/php74安装pgsql扩展"],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
      {
        title: "GIT",
        children: ["/git/常用git命令", "/git/生成sshkey"],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
      {
        title: "Linux",
        children: [
          "/linux/阿里云centos磁盘扩容",
          "/linux/删除.user.ini文件",
          "/linux/删除某时间前的文件或文件夹",
          "/linux/centos7防火墙",
          "/linux/docker操作",
          "/linux/linux常用命令",
          "/linux/linux改网卡名",
          "/linux/ssh客户端保持连接",
          "/linux/ssh免密码连接服务器",
          "/linux/tmux操作",
          "/linux/ubuntu配静态IP",
          "/linux/ubuntu配置nfs服务",
          "/linux/vim操作",
        ],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
      {
        title: "Docker",
        children: [
          "/docker/Debian11下安装docker和docker-compose",
          "/docker/配置Docker Hub国内镜像加速",
          "/docker/docker部署gitea服务",
          "/docker/docker部署minio服务",
          "/docker/docker部署postgres数据库服务",
          "/docker/docker部署rabbitmq启用stomp和延时队列",
        ],
        initialOpenGroupIndex: 0, // 可选的, 默认值是 0
        sidebarDepth: 0, // 可选的, 默认值是 1
      },
    ],
  },
};
